
// SndPackDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SndPack.h"
#include "SndPackDlg.h"
#include "pack.h"
#include "SndType.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSndPackDlg dialog

static TCHAR* GetType(int type)
{
	switch (type)
	{
		case 1: return L"HUM";
		case 2: return L"OFF";
		case 3: return L"ON";
		case 4: return L"HIT";
		case 5: return L"STK";
		case 6: return L"SWI";
		default: return L"UNK";
	}
}

CSndPackDlg::CSndPackDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSndPackDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSndPackDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST1, m_List);
}

BEGIN_MESSAGE_MAP(CSndPackDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, &CSndPackDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, &CSndPackDlg::OnBnClickedCancel)
	ON_BN_CLICKED(IDC_OPEN, &CSndPackDlg::OnBnClickedOpen)
	ON_BN_CLICKED(IDC_ADDFILE, &CSndPackDlg::OnBnClickedAddfile)
	ON_BN_CLICKED(IDC_SAVE, &CSndPackDlg::OnBnClickedSave)
	ON_BN_CLICKED(IDC_NEW, &CSndPackDlg::OnBnClickedNew)
	ON_BN_CLICKED(IDC_DELETE, &CSndPackDlg::OnBnClickedDelete)
END_MESSAGE_MAP()


// CSndPackDlg message handlers

BOOL CSndPackDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSndPackDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSndPackDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CSndPackDlg::OnBnClickedOk()
{
	
}

void CSndPackDlg::OnBnClickedCancel()
{
	pack_new();
	OnCancel();
}

void CSndPackDlg::OnBnClickedOpen()
{
	CFileDialog fd(TRUE, L"BIN");

	fd.GetOFN().lpstrFilter = L"BIN File\0*.bin\0All\0*.*\0";
	fd.GetOFN().nFilterIndex = 1;
	
	if (fd.DoModal() == IDOK) {
		CFile file;

		file.Open(fd.GetOFN().lpstrFile, CFile::modeRead);
		BYTE* buf = (BYTE*) malloc((size_t)file.GetLength());
		file.Read(buf, (DWORD) file.GetLength());

		pack_open(buf, (DWORD) file.GetLength());

		file.Close();
		free(buf);

		UpdateList();
	}
}

void CSndPackDlg::OnBnClickedAddfile()
{
	CFileDialog fd(TRUE, L"WAV");

	fd.GetOFN().lpstrFilter = L"WAV File\0*.wav\0All\0*.*\0";
	fd.GetOFN().nFilterIndex = 1;
	
	if (fd.DoModal() == IDOK) {
		CSndType SndType;

		if (SndType.DoModal() == IDOK)
		{
			CFile file;

			file.Open(fd.GetOFN().lpstrFile, CFile::modeRead);
			BYTE* buf = (BYTE*) malloc((size_t)file.GetLength());
			file.Read(buf, (DWORD) file.GetLength());

			pack_add(buf, (DWORD) file.GetLength(), SndType.m_iType);

			file.Close();
			free(buf);
			UpdateList();
		}
	}
}

void CSndPackDlg::OnBnClickedSave()
{
	CFileDialog fd(FALSE, L"BIN");

	fd.GetOFN().lpstrFilter = L"BIN File\0*.bin\0All\0*.*\0";
	fd.GetOFN().nFilterIndex = 1;
	
	if (fd.DoModal() == IDOK) {
		CFile file;

		file.Open(fd.GetOFN().lpstrFile, CFile::modeReadWrite | CFile::modeCreate);

		BYTE* buf = (BYTE*) malloc((size_t) pack_calculate_size());
		
		DWORD size = pack_get_blob(buf);

		file.Write(buf, size);

		file.Close();
		free(buf);

		UpdateList();
	}
}

void CSndPackDlg::OnBnClickedNew()
{
	pack_new();
	UpdateList();
}

void CSndPackDlg::UpdateList()
{
	SND_HEADER* hdr = pack_get_header();
	SND_DESC* desc;

	m_List.ResetContent();

	desc = hdr->first;

	while (desc)
	{
		CString str;
		str.Format(L"Type=%s Offs=%i Len=%i", GetType(desc->type), desc->offs, desc->len);
		m_List.AddString(str);
		desc = desc->next;
	}
}

void CSndPackDlg::OnBnClickedDelete()
{
	int iSel = m_List.GetCurSel();

	if (iSel == -1) return;
	pack_remove(iSel+1);
	UpdateList();
}
